/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fidentis.analyst.tests;

import cz.fidentis.analyst.batch.Stopwatch;
import cz.fidentis.analyst.face.HumanFace;
import cz.fidentis.analyst.face.HumanFaceFactory;
import cz.fidentis.analyst.face.HumanFaceUtils;
import cz.fidentis.analyst.feature.FeaturePoint;
import cz.fidentis.analyst.feature.services.FeaturePointImportService;
import cz.fidentis.analyst.feature.utils.FileResourcesUtils;
import cz.fidentis.analyst.visitors.mesh.HausdorffDistance;
import cz.fidentis.analyst.visitors.mesh.sampling.CurvatureSampling;
import cz.fidentis.analyst.visitors.mesh.sampling.NoSampling;
import cz.fidentis.analyst.visitors.mesh.sampling.PointSampling;
import cz.fidentis.analyst.visitors.mesh.sampling.RandomSampling;
import cz.fidentis.analyst.visitors.mesh.sampling.UniformSpaceSampling;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.stream.Collectors;

/**
 *
 * @author Jakub Kolman
 */
public class ProcrustesVisitorTest {
    private static final String DATA_DIR = "./src/test/resources/cz/fidentis/analyst";
    private static final int MAX_SAMPLES = 100;
    private static final String FACE_1 = "0002_01_ECA.obj";
    private static final String FACE_2 = "0002_02_ECA.obj";
    private static final String FACE_FP_1 = "0002_01_landmarks.csv";
    private static final String FACE_FP_2 = "0002_02_landmarks.csv";
    private static final String FACE_FP_ROTATION_1 = "rotation_landmarks.csv";
    private static final String FACE_FP_ROTATION_2 = "rotation_180_moved_2_landmarks.csv";
    private static final String FACE_FP_TWOS = "twos_landmarks.csv";
    private static final String FACE_FP_FOURS = "fours_landmarks.csv";
    
    /**
     * Main method 
     * @param args Input arguments 
     * @throws IOException on IO error
     */
    public static void main(String[] args) throws IOException, ClassNotFoundException, Exception {
        FileResourcesUtils fru = new FileResourcesUtils();
        HumanFaceFactory factory = new HumanFaceFactory();
                FeaturePointImportService featurePointImportService = new FeaturePointImportService();

        List<FeaturePoint> fpList1 = featurePointImportService.importFeaturePoints(
                DATA_DIR.toString(), FACE_FP_ROTATION_1);
        List<FeaturePoint> fpList2= featurePointImportService.importFeaturePoints(
                DATA_DIR.toString(), FACE_FP_ROTATION_2);

        
            HumanFace face1 = factory.getFace(factory.loadFace(
                fru.getFile(DATA_DIR.toString(), FACE_1)));
            HumanFace face2 = factory.getFace(factory.loadFace(
                fru.getFile(DATA_DIR.toString(), FACE_2)));
            
            face1.setFeaturePoints(fpList1);
            face2.setFeaturePoints(fpList2);
            
            tryProcrustesVisitor(face1, face2);
        }

    protected static void tryProcrustesVisitor(HumanFace face1, HumanFace face2) {
                    HumanFaceUtils.alignFeaturePoints(face1, face2, true, false);
//                    HumanFaceUtils.alignFeaturePoints(face1, face2, true, false);
    }
    
 
}


